#include "clientreader.h"
#include "clientwriter.h"
#include "server.h"

#include <iostream>
#include <string>

int main(int argc, char** argv) {
	std::cout << "Hello! This is a Nazvanie Prilozhenia, kotoroe ya ne pridumal" << std::endl;
	std::cout << "Please, tell me, would you like to start a server " 
			  << "(type \"server\") or a client (type \"client\"): ";

    std::string command;
    std::cin >> command;

    if (command == "server") {
    	// Если пользователь ввёл server - то создаём класс сервера и запускаем функцию exec
    	Server server;
    	return server.exec();
    }

    if (command == "client") {
    	// Если пользователь ввёл client - узнаём, читатель он или писатель

    	std::cout << "Please, tell me, would you like to be a writer (type \"writer\") or a reader (type \"reader\"): ";
    	std::string user_type;
    	std::cin >> user_type;

    	if (user_type == "writer") {
    		// Если пользователь ввёл writer - создаём класс клиента-писателя и запускаем его функцию exec
    		ClientWriter writer;
    		return writer.exec();
    	}

    	if (user_type == "reader") {
    		// Если пользователь ввёл reader - создаём класс клиента-читателя и запускаем его функцию exec
    		ClientReader reader;
    		return reader.exec();
    	}

    	// Если то, что было введено - не writer и не reader - пишем сообщение об ошибке и завершаем программу
		std::cout << "Incorrect user type, exiting :(" << std::endl;
		return -1;
    }


    // Если то, что было введено - не server и не client - пишем сообщение об ошибке и завершаем программу
    std::cout << "Incorrect command, exiting :(" << std::endl;
    return -1;
}